const APP_DISPLAY_NAME = "FlagFox";
const APP_NAME = "flagfox";
const APP_AUTHOR = "Joseph Birr-Pixton (ctz)";
const APP_VERSION = "3.1.2";
const APP_LOCALES = [
"en-US", "ar",    "de-DE", "es-ES", "fi-FI", "fr-FR", "he-IL", "it-IT",
"ja-JP", "ko-KR", "nl-NL", "pl-PL", "pt-BR", "pt-PT", "zh-CN", "zh-TW"]
const SKIN_TYPE = "classic";

const APP_PACKAGE = "/"+APP_AUTHOR+"/"+APP_NAME;
const APP_JAR_SOURCE_FILE = "chrome/"+APP_NAME+".jar";
const APP_JAR_FINAL_FILE = APP_NAME+".jar";
const APP_CONTENT_FOLDER = "content/"+APP_NAME+"/";
// const APP_LOCALE_FOLDER  = "locale/"+APP_LOCALE+"/"+APP_NAME+"/";
// const APP_SKIN_FOLDER  = "skin/"+SKIN_TYPE+"/"+APP_NAME+"/";
const APP_DB_SOURCE_FILE = "db.dat";

const APP_SUCCESS_MESSAGE = "You may need to restart your browser.";

//const INST_TO_PROFILE = "Do you wish to install "+APP_DISPLAY_NAME+" to your profile?\nHere it need not be reinstalled when you update your browser.\n(Click Cancel to install to the application directory.)";

initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);

// give the option to install to the application directory (commented out)
// (profile installs only work since 2003-03-06)
var destFolder = getFolder("Profile", "chrome");
var chromeType = PROFILE_CHROME;
//if (!confirm(INST_TO_PROFILE)) {
//  destFolder = getFolder("Chrome");
//  chromeType = DELAYED_CHROME;
//}

var err;
var installedFile;
err = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_SOURCE_FILE,
              destFolder, APP_JAR_FINAL_FILE);

if (err == SUCCESS) {
  addFile(APP_PACKAGE, APP_VERSION, APP_DB_SOURCE_FILE,
              getFolder("Profile"), APP_DB_SOURCE_FILE);
  addFile(APP_PACKAGE, APP_VERSION, "defaults/preferences/prefs.js",
              getFolder(getFolder("Program", "defaults"), "pref"),
              "flagfox-prefs.js");

  installedFile = getFolder(destFolder, APP_JAR_FINAL_FILE);
  registerChrome(CONTENT | chromeType, installedFile, APP_CONTENT_FOLDER);
//  registerChrome(SKIN  | chromeType, installedFile, APP_SKIN_FOLDER);
  for (var idx in APP_LOCALES) {
    registerChrome(LOCALE  | chromeType, installedFile,
                   "locale/"+APP_LOCALES[idx]+"/");
  }
  err = performInstall();
  if (err == SUCCESS || err == REBOOT_NEEDED)
    alert(APP_DISPLAY_NAME+" "+APP_VERSION+" has been succesfully installed.\n"+
          APP_SUCCESS_MESSAGE);
  else {
    alert("Install failed. Error code:" + err);
    cancelInstall(err);
  }
} else {
  alert("Failed to create " +APP_JAR_FINAL_FILE +"\n"+
        "You probably don't have write access\n"+
        "to your profile or chrome directory.\n"+
        "____________________________________\n"+
        "Error code:" + err);
  cancelInstall(err);
}
